Index: release-kits/lirk3/ant-scripts/compile.xml
===================================================================
--- release-kits/lirk3/ant-scripts/compile.xml	(revision 16171)
+++ release-kits/lirk3/ant-scripts/compile.xml	(revision 16172)
@@ -1,12 +1,3 @@
 <?xml version="1.0" encoding="utf-8" ?>
-
-<!--
-		.......................................................... 
-		September 2007
-		Greenstone3 'release maker' script
-		Oran Fry
-		..........................................................
--->
-
 <project name="lirk3-compile" default="compile">
 
@@ -38,11 +29,4 @@
 
 	</target>
-
-
-	<!--
-
-		second level targets
-
-	-->
 
 	<target name="checkout-greenstone3">
@@ -152,5 +136,4 @@
 	</target>
 
-
 	<!--
 
Index: release-kits/lirk3/ant-scripts/create-distribution.xml
===================================================================
--- release-kits/lirk3/ant-scripts/create-distribution.xml	(revision 16171)
+++ release-kits/lirk3/ant-scripts/create-distribution.xml	(revision 16172)
@@ -1,12 +1,3 @@
 <?xml version="1.0" encoding="utf-8" ?>
-
-<!--
-		.......................................................... 
-		September 2007
-		Greenstone3 'release maker' script
-		Oran Fry
-		..........................................................
--->
-
 <project name="lirk3-create-distribution" default="create-distribution">
 
@@ -24,12 +15,4 @@
 	</target>
 
-
-
-	<!--
-
-		second level targets
-
-	-->
-	
 	<target name="export-greenstone3">
 		<if><bool><istrue value="${execute}"/></bool>
Index: release-kits/lirk3/ant-scripts/create-installer.xml
===================================================================
--- release-kits/lirk3/ant-scripts/create-installer.xml	(revision 16171)
+++ release-kits/lirk3/ant-scripts/create-installer.xml	(revision 16172)
@@ -1,12 +1,3 @@
 <?xml version="1.0" encoding="utf-8" ?>
-
-<!--
-		.......................................................... 
-		September 2007
-		Greenstone3 'release maker' script
-		Oran Fry
-		..........................................................
--->
-
 <project name="lirk3-create-installer" default="create-installer">
 
@@ -33,8 +24,5 @@
 			<copy todir="${basedir}/installer" file="${lirk3.home}/installer/build.xml" overwrite="true" />
 			<copy todir="${basedir}/installer/resources" overwrite="true">
-				<fileset dir="${lirk3.home}/installer/resources">
-					<include name="*.properties"/>
-					<include name="*.png"/>
-				</fileset>
+				<fileset dir="${lirk3.home}/greenstone3/installer-resources"/>
 			</copy>
 
@@ -76,6 +64,6 @@
 					installConfig="${basedir}/installer/antinstall-config.xml"
 					buildFile="${basedir}/installer/build.xml"
-					antInstallLib="${lirk3.home}/bin/ant-installer/lib"
-					antLib="${lirk3.home}/bin/apache-ant-1.6.5/lib"
+					antInstallLib="${lirk3.home}/packages/ant-installer/lib"
+					antLib="${lirk3.home}/packages/ant/lib"
 					validateConfig="true"
 					failOnError="false"
@@ -108,6 +96,6 @@
 					installConfig="${basedir}/installer/antinstall-config.xml"
 					buildFile="${basedir}/installer/build.xml"
-					antInstallLib="${lirk3.home}/bin/ant-installer/lib"
-					antLib="${lirk3.home}/bin/apache-ant-1.6.5/lib"
+					antInstallLib="${lirk3.home}/packages/ant-installer/lib"
+					antLib="${lirk3.home}/packages/ant/lib"
 					validateConfig="true"
 					icons="bluecurve">
Index: release-kits/lirk3/ant-scripts/operations-on-gs3home.xml
===================================================================
--- release-kits/lirk3/ant-scripts/operations-on-gs3home.xml	(revision 16171)
+++ release-kits/lirk3/ant-scripts/operations-on-gs3home.xml	(revision 16172)
@@ -138,9 +138,9 @@
 
 	<target name="run-xslt-binary" depends="init">
-		<xslt in="${basedir}/build.xml" out="${basedir}/modified-build.xml" style="${lirk3.home}/xsl/convert-build-xml.xsl"/>
+		<xslt in="${basedir}/build.xml" out="${basedir}/modified-build.xml" style="${lirk3.home}/greenstone3/xsl/convert-build-xml.xsl"/>
 	</target>
 
 	<target name="run-xslt-source" depends="init">
-		<xslt in="${basedir}/build.xml" out="${basedir}/modified-build.xml" style="${lirk3.home}/xsl/convert-build-xml-source.xsl"/>
+		<xslt in="${basedir}/build.xml" out="${basedir}/modified-build.xml" style="${lirk3.home}/greenstone3/xsl/convert-build-xml-source.xsl"/>
 	</target>
   
Index: release-kits/lirk3/ant-scripts/wrap.xml
===================================================================
--- release-kits/lirk3/ant-scripts/wrap.xml	(revision 16171)
+++ release-kits/lirk3/ant-scripts/wrap.xml	(revision 16172)
@@ -1,12 +1,3 @@
 <?xml version="1.0" encoding="utf-8" ?>
-
-<!--
-		.......................................................... 
-		 September 2007
-		 Greenstone3 'release maker' script
-		 Oran Fry
-		..........................................................
--->
-
 <project name="lirk3-wrap" default="wrap">
 
@@ -15,5 +6,4 @@
 		<addressedcall target="compile-wrapper"/>
 	</target>
-
 
 	<target name="setup-for-wrapping">
@@ -25,5 +15,5 @@
 
 			<!-- copy bundled files -->
-			<copy todir="${basedir}/wrapped-installer/build" file="${lirk3.home}/search4j/search4j" />
+			<copy todir="${basedir}/wrapped-installer/build" file="${lirk3.home}/packages/search4j/search4j" />
 			<copy todir="${basedir}/wrapped-installer/build" file="${lirk3.home}/linux/${java.installer}"/>
 			<copy todir="${basedir}/wrapped-installer/build" file="${basedir}/installer/greenstone3.jar"/>