Index: release-kits/lirk2/ant-scripts/build.xml
===================================================================
--- release-kits/lirk2/ant-scripts/build.xml	(revision 16168)
+++ release-kits/lirk2/ant-scripts/build.xml	(revision 16175)
@@ -3,6 +3,6 @@
 <!--
 		.......................................................... 
-		September 2007
-		Greenstone3 'release maker' script
+		June 2008
+		Linux Release Kit for Greenstone3 (lirk3)
 		Oran Fry
 		..........................................................
@@ -11,6 +11,11 @@
 <project name="lirk2-build" default="lirk2">
 
-	<import file="init.xml"/>
+	<!-- CONSTANTS -->
 
+	<!-- for the benefit of the shared scripts, set release-kit home -->
+	<property name="rk.home" value="${lirk2.home}" />
+
+	<!-- IMPORT OTHER ANT SCRIPTS -->
+	<import file="shared-ant-scripts/init.xml"/>
 	<import file="compile.xml"/>
 	<import file="create-distribution.xml"/>
@@ -18,4 +23,5 @@
 	<import file="wrap.xml"/>
 
+	<!-- THE MAIN TARGET -->
 	<target name="lirk2" depends="init">
 		<addressedcall target="compile"/>
Index: release-kits/lirk2/ant-scripts/compile.xml
===================================================================
--- release-kits/lirk2/ant-scripts/compile.xml	(revision 16168)
+++ release-kits/lirk2/ant-scripts/compile.xml	(revision 16175)
@@ -1,14 +1,4 @@
 <?xml version="1.0" encoding="utf-8" ?>
-
-<!--
-		.......................................................... 
-		September 2007
-		Greenstone3 'release maker' script
-		Oran Fry
-		..........................................................
--->
-
 <project name="lirk2-compile" default="compile">
-
 
 	<target name="compile">
@@ -34,11 +24,4 @@
 
 	</target>
-
-
-	<!--
-
-		second level targets
-
-	-->
 
 	<target name="checkout-gsdl-indexers-gli">
@@ -121,5 +104,5 @@
 	<target name="build-demo-collection">
 		<if><bool><istrue value="${execute}"/></bool>
-			<exec dir="${basedir}/gsdl" executable="${lirk2.home}/compile/build-demo.sh"/>
+			<exec dir="${basedir}/gsdl" executable="${lirk2.home}/resources/build-demo.sh"/>
 		</if>
 	</target>
Index: release-kits/lirk2/ant-scripts/create-installer.xml
===================================================================
--- release-kits/lirk2/ant-scripts/create-installer.xml	(revision 16168)
+++ release-kits/lirk2/ant-scripts/create-installer.xml	(revision 16175)
@@ -1,12 +1,3 @@
 <?xml version="1.0" encoding="utf-8" ?>
-
-<!--
-		.......................................................... 
-		September 2007
-		Greenstone3 'release maker' script
-		Oran Fry
-		..........................................................
--->
-
 <project name="lirk2-create-installer" default="create-installer">
 
@@ -24,15 +15,12 @@
 			<copy todir="${basedir}/installer" file="${lirk2.home}/installer/build.xml" overwrite="true"/>
 			<copy todir="${basedir}/installer/resources" overwrite="true">
-				<fileset dir="${lirk2.home}/installer/resources">
-					<include name="*.properties"/>
-					<include name="*.png"/>
-				</fileset>
+				<fileset dir="${lirk2.home}/greenstone2/installer-resources"/>
 			</copy>
 
 			<!-- put the concrete values of things in the config -->
 			<rsr file="${basedir}/installer/antinstall-config.xml" pattern="@version@" replacement="${version}"/>
-			<rsr file="${basedir}/installer/antinstall-config.xml" pattern="@component.size.java@" replacement="${component.size.java}"/>
+			<rsr file="${basedir}/installer/antinstall-config.xml" pattern="@component.size.java@" replacement="${component.size.linux-java}"/>
 			<rsr file="${basedir}/installer/build.xml" pattern="@java.min.version@" replacement="${java.min.version}"/>
-			<rsr file="${basedir}/installer/build.xml" pattern="@java.extracted@" replacement="${java.extracted}"/>
+			<rsr file="${basedir}/installer/build.xml" pattern="@java.extracted@" replacement="${linux-java.extracted}"/>
 
 			<!-- put the concrete values of things in the text -->
@@ -40,5 +28,5 @@
 			<rsr file="${basedir}/installer/resources/LanguagePack.properties" pattern="@version@" replacement="${version}"/>
 			<rsr file="${basedir}/installer/resources/LanguagePack.properties" pattern="@java.min.version@" replacement="${java.min.version}"/>
-			<rsr file="${basedir}/installer/resources/LanguagePack.properties" pattern="@bundled.version.java@" replacement="${bundled.version.java}"/>
+			<rsr file="${basedir}/installer/resources/LanguagePack.properties" pattern="@bundled.version.java@" replacement="${bundled.version.linux-java}"/>
 
 			<!-- chinese -->
@@ -64,6 +52,6 @@
 					installConfig="${basedir}/installer/antinstall-config.xml"
 					buildFile="${basedir}/installer/build.xml"
-					antInstallLib="${lirk2.home}/bin/ant-installer/lib"
-					antLib="${lirk2.home}/bin/apache-ant-1.6.5/lib"
+					antInstallLib="${lirk2.home}/packages/ant-installer/lib"
+					antLib="${lirk2.home}/packages/ant/lib"
 					validateConfig="true"
 					failOnError="false"
@@ -85,6 +73,6 @@
 					installConfig="${basedir}/installer/antinstall-config.xml"
 					buildFile="${basedir}/installer/build.xml"
-					antInstallLib="${lirk2.home}/bin/ant-installer/lib"
-					antLib="${lirk2.home}/bin/apache-ant-1.6.5/lib"
+					antInstallLib="${lirk2.home}/packages/ant-installer/lib"
+					antLib="${lirk2.home}/packages/ant/lib"
 					validateConfig="true"
 					failOnError="false"
Index: release-kits/lirk2/ant-scripts/init.xml
===================================================================
--- release-kits/lirk2/ant-scripts/init.xml	(revision 16168)
+++ 	(revision )
@@ -1,173 +1,0 @@
-<?xml version="1.0" encoding="utf-8" ?>
-
-<!--
-		.......................................................... 
-		September 2007
-		Greenstone3 'release maker' script
-		Oran Fry
-		..........................................................
--->
-
-<project name="lirk2-init">
-
-	<!-- classpath -->
-	<path id="project.classpath">
-		<fileset dir="${lirk2.home}/ant-scripts/tasks">
-			<include name="**/*.jar"/>
-		</fileset>
-		<fileset dir="${lirk2.home}/lib">
-			<include name="*.jar"/>
-		</fileset>
-		<fileset dir="${lirk2.home}/bin/ant-installer/lib">
-			<include name="ant-installer-ext.jar"/>
-			<include name="ant-installer.jar"/>
-		</fileset>
-		<pathelement path="${lirk2.home}/ant-scripts/tasks/orans"/>
-
-		<pathelement path="${basedir}/installer/cp"/>
-	</path>
-
-	<!-- svn root -->
-	<property name="svn.root" value="http://svn.greenstone.org"/>
-
-	<!-- self defined tasks -->
-	<taskdef name="if" classname="ise.antelope.tasks.IfTask" classpathref="project.classpath"/>
-	<taskdef name="try" classname="ise.antelope.tasks.TryTask" classpathref="project.classpath"/>
-	<taskdef name="svn" classname="org.tigris.subversion.svnant.SvnTask" classpathref="project.classpath"/>
-	<taskdef name="setloglevel" classname="SetLogLevel" classpathref="project.classpath"/>
-	<typedef name="addressedcall" classname="TreeCallTarget" classpathref="project.classpath"/>
-	<typedef name="rsr" classname="RegexSearchReplace" classpathref="project.classpath"/>
-	<taskdef name="installer" classname="org.tp23.antinstaller.taskdefs.Installer" classpathref="project.classpath"/>
-
-	<!-- load in static properties from build.properties -->
-	<property file="build.properties" />
-
-	<!-- somewhere to store temporary text -->
-	<tempfile property="temp.file" destdir="${java.io.tmpdir}" prefix="delete" suffix=".tmp"/>
-
-	<!-- bundled java strings -->
-	<!-- java.installer: use a filename which has only letters numbers and underscores -->
-
-	<!-- the version numbers of bundled things -->
-	<property name="bundled.version.java" value="1.6.0_05"/>
-
-	<!--<property name="java.installer" value="jre_6u5_linux_i586"/>-->
-	<property name="java.installer" value="jre_6u5_tar_gz"/>
-	<property name="java.extracted" value="jre1.6.0_05"/>
-	<property name="java.min.version" value="1.4.0_00"/>
-
-
-	<!-- stuff to do before all tasks -->
-	<target name="init">
-
-		<!-- verify classpath -->
-		<!--
-		<property name="cpp" refid="project.classpath"/>
-		<echo message="classpath: ${cpp}"/>
-		-->
-
-		<echo level="info">CHECKING PRE-CONDITIONS</echo>
-		<echo level="info"/>
-
-		<!-- version number -->
-		<echo level="info">Version number...</echo>
-		<if>
-			<bool>
-				<not><isset property="version"/></not>
-			</bool>
-			<fail>Version number not set</fail>
-		</if>
-
-		<echo level="info">Version number: ${version}</echo>
-		<property name="app.version" value="${version}"/>
-		<echo level="info"/>
-
-		<!-- check resume from -->
-		<echo level="info">Checking if we are resuming from a given target...</echo>
-		<if>
-			<bool><not><isset property="resume.from"/></not></bool>
-			<echo level="info">No, start from the beginning</echo>
-			<else>
-				<echo level="info">Yes, resuming from ${resume.from}</echo>
-			</else>
-		</if>
-		<echo level="info"/>
-
-		<!-- check resume to -->
-		<echo level="info">Checking if we are resuming up to a given target...</echo>
-		<if>
-			<bool><not><isset property="resume.to"/></not></bool>
-			<echo level="info">No, stop at the end</echo>
-			<else>
-				<echo level="info">Yes, resuming from ${resume.to}</echo>
-			</else>
-		</if>
-		<echo level="info"/>
-
-
-		<!-- check resume mode-->
-		<echo level="info">Determining resume mode...</echo>
-		<if>
-			<bool>
-				<not><isset property="resume.mode"/></not>
-			</bool>
-			<echo level="info">Mode not set, just fall through</echo>
-			<else>
-				<echo level="info">Mode set to ${resume.mode}</echo>
-				<if>
-					<bool>
-						<not><equals arg1="${resume.mode}" arg2="descend"/></not>
-					</bool>
-					<echo level="error">You have not specified a valid resume mode.</echo>
-					<echo level="error">Valid modes are 'descend' and null.</echo>
-					<fail>You have not specified a valid resume mode.</fail>
-				</if>
-			</else>
-		</if>
-		<echo level="info"/>
-
-		<!-- execute target code or just traverse tree -->
-		<echo level="info">Determining execute mode...</echo>
-		<if>
-			<bool>
-				<not><isset property="execute"/></not>
-			</bool>
-			<echo level="info">Execute not set, defaulting to 'true'</echo>
-			<property name="execute" value="true"/>
-			<else>
-				<echo level="info">Execute set to ${execute}</echo>
-				<if>
-					<bool>
-						<and>
-							<not><equals arg1="${execute}" arg2="true"/></not>
-							<not><equals arg1="${execute}" arg2="false"/></not>
-						</and>
-					</bool>
-					<echo level="error">You have not specified a valid value for execute.</echo>
-					<echo level="error">Valid values are 'true' and 'false'.</echo>
-					<fail>You have not specified a valid value for execute.</fail>
-				</if>
-			</else>
-		</if>
-
-		<echo level="info"/>
-
-
-		<!-- check branch.path -->
-		<echo level="info">Determining the branch path...</echo>
-		<if>
-			<bool><equals arg1="trunk" arg2="${version}"/></bool>
-			<property name="branch.path" value="trunk"/>
-		</if>
-
-		<if>
-			<bool><not><isset property="branch.path"/></not></bool>
-			<fail>You have not specified a branch path where code will come from in the repository</fail>
-		</if>
-
-		<echo level="info">Branch Path: ${branch.path}</echo>
-		<echo level="info"/>
-
-	</target>
-
-</project>
Index: release-kits/lirk2/ant-scripts/wrap.xml
===================================================================
--- release-kits/lirk2/ant-scripts/wrap.xml	(revision 16168)
+++ release-kits/lirk2/ant-scripts/wrap.xml	(revision 16175)
@@ -1,12 +1,3 @@
 <?xml version="1.0" encoding="utf-8" ?>
-
-<!--
-		.......................................................... 
-		 September 2007
-		 Greenstone3 'release maker' script
-		 Oran Fry
-		..........................................................
--->
-
 <project name="lirk2-wrap" default="wrap">
 
@@ -25,13 +16,13 @@
 
 			<!-- copy bundled files -->
-			<copy todir="${basedir}/wrapped-installer/build" file="${lirk2.home}/search4j/search4j"/>
-			<copy todir="${basedir}/wrapped-installer/build" file="${lirk2.home}/linux/${java.installer}"/>
+			<copy todir="${basedir}/wrapped-installer/build" file="${lirk2.home}/packages/search4j/search4j"/>
+			<copy todir="${basedir}/wrapped-installer/build" file="${lirk2.home}/linux/${linux-java.installer}"/>
 			<copy tofile="${basedir}/wrapped-installer/build/greenstone2.jar" file="${basedir}/installer/greenstone-${version}-linux.jar"/>
 			<copy tofile="${basedir}/wrapped-installer/build/greenstone2-with-java.jar" file="${basedir}/installer/greenstone-${version}-linux-with-java.jar"/>
 
 			<!-- substitute in real values -->
-			<rsr file="${basedir}/wrapped-installer/build/wrapper.cpp" pattern="@java.installer@" replacement="${java.installer}"/>
+			<rsr file="${basedir}/wrapped-installer/build/wrapper.cpp" pattern="@java.installer@" replacement="${linux-java.installer}"/>
 			<rsr file="${basedir}/wrapped-installer/build/wrapper.cpp" pattern="@installer.name@" replacement="greenstone2"/>
-			<rsr file="${basedir}/wrapped-installer/build/wrapper.cpp" pattern="@java.extracted@" replacement="${java.extracted}"/>
+			<rsr file="${basedir}/wrapped-installer/build/wrapper.cpp" pattern="@java.extracted@" replacement="${linux-java.extracted}"/>
 			<rsr file="${basedir}/wrapped-installer/build/wrapper.cpp" pattern="@java.min.version@" replacement="${java.min.version}"/>
 
@@ -53,5 +44,5 @@
 			</exec>
 			<exec executable="/usr/bin/objcopy" dir="${basedir}/wrapped-installer/build">
-				<arg line="-I binary -O elf32-i386 -B i386 --redefine-sym _binary_${java.installer}_start=java --readonly-text ${java.installer} java.o"/>
+				<arg line="-I binary -O elf32-i386 -B i386 --redefine-sym _binary_${linux-java.installer}_start=java --readonly-text ${linux-java.installer} java.o"/>
 			</exec>
 
@@ -69,5 +60,5 @@
 
 			<!-- get size of java -->
-			<exec executable="ls" dir="${basedir}/wrapped-installer/build" outputproperty="java.ls"><arg line="-l ${java.installer}"/></exec>
+			<exec executable="ls" dir="${basedir}/wrapped-installer/build" outputproperty="java.ls"><arg line="-l ${linux-java.installer}"/></exec>
 			<exec executable="sed" inputstring="${java.ls}" outputproperty="java.size"><arg line="-e 's/^[^\ ]*\ *[^\ ]*\ *[^\ ]*\ *[^\ ]*\ *\([0-9]*\).*$/\1/g'"/></exec>
 
Index: release-kits/lirk2/bin/lirk2
===================================================================
--- release-kits/lirk2/bin/lirk2	(revision 16168)
+++ release-kits/lirk2/bin/lirk2	(revision 16175)
@@ -1,4 +1,4 @@
 function show_help {
-	echo "LiRK2 - the LInux Release Kit for greenstone3"
+	echo "lirk2 - the LInux Release Kit for greenstone3"
 	echo "Helps you to create releases of Greenstone2 from the Repository"
 	echo
@@ -29,15 +29,14 @@
 	CLASSPATH=$CLASSPATH:$file
 done
-for file in $LIRK2_HOME/bin/apache-ant-1.6.5/lib/*.jar; do
+for file in $LIRK2_HOME/packages/ant/lib/*.jar; do
 	CLASSPATH=$CLASSPATH:$file
 done
-for file in $LIRK2_HOME/bin/ant-installer/lib/*.jar; do
+for file in $LIRK2_HOME/packages/ant-installer/lib/*.jar; do
 	CLASSPATH=$CLASSPATH:$file
 done
-CLASSPATH=$CLASSPATH:$LIRK2_HOME/bin/ant-installer/classes
-
+CLASSPATH=$CLASSPATH:$LIRK2_HOME/packages/ant-installer/classes
 
 #create the command
-toexec="$LIRK2_HOME/bin/apache-ant-1.6.5/bin/ant -lib `pwd`/installer -f $LIRK2_HOME/ant-scripts/build.xml -Dbasedir=`pwd` -Dlirk2.home=$LIRK2_HOME"
+toexec="$LIRK2_HOME/packages/ant/bin/ant -lib `pwd`/installer -f $LIRK2_HOME/ant-scripts/build.xml -Dbasedir=`pwd` -Dlirk2.home=$LIRK2_HOME"
 
 #pass on the arguments